# Look for the header file.
FIND_PATH(ICU_INCLUDE_DIR NAMES unicode/uchar.h)
MARK_AS_ADVANCED(ICU_INCLUDE_DIR)

# Look for the library.
FIND_LIBRARY(ICU_LIB1 NAMES icui18n icuin icuind)
FIND_LIBRARY(ICU_LIB2 NAMES icuuc icuucd)
FIND_LIBRARY(ICU_LIB3 NAMES icudata icudt)
MARK_AS_ADVANCED(ICU_LIB1)
MARK_AS_ADVANCED(ICU_LIB2)
MARK_AS_ADVANCED(ICU_LIB3)

# handle the QUIETLY and REQUIRED arguments and set ICU_FOUND to TRUE if 
# all listed variables are TRUE
INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(ICU DEFAULT_MSG ICU_LIB1 ICU_LIB2 ICU_LIB3 ICU_INCLUDE_DIR)

IF(ICU_FOUND)
  SET(ICU_LIBRARIES ${ICU_LIB1} ${ICU_LIB2} ${ICU_LIB3}  )
  SET(ICU_INCLUDE_DIRS ${ICU_INCLUDE_DIR})
ELSE(ICU_FOUND)
  SET(ICU_LIBRARIES)
  SET(ICU_INCLUDE_DIRS)
ENDIF(ICU_FOUND)

