# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# Copyright 2010-2011 SourceGear, LLC
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

SET (PACKAGEMAKER_ROOT_DIRS
	"/Developer/usr/bin"
	"/usr/bin"
	"/bin"
)

FIND_PATH(PACKAGEMAKER_ROOT
	NAMES 
	packagemaker
PATHS ${PACKAGEMAKER_ROOT_DIRS})

SET(PACKAGEMAKER_FOUND OFF)
IF(PACKAGEMAKER_ROOT)
  SET(PACKAGEMAKER_FOUND ON)
  SET(PACKAGEMAKER_PATH "${PACKAGEMAKER_ROOT}/packagemaker" CACHE STRING "PackageMaker Path")
ENDIF(PACKAGEMAKER_ROOT)

IF(NOT PACKAGEMAKER_FOUND)
	MESSAGE(FATAL_ERROR
      "PackageMaker required but not found. Please ensure you hav Xcode installed.")
ELSE()
	MESSAGE(STATUS "PackageMaker path: ${PACKAGEMAKER_PATH}")
ENDIF()