/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 * "Throws" SG_ERR_NOT_A_WORKING_COPY if the cwd's not inside a working copy.
 */
void SG_cmd_util__get_descriptor_name_from_cwd(SG_context* pCtx, SG_string** ppstrDescriptorName, SG_pathname** ppPathCwd);

/**
 * "Throws" SG_ERR_NOT_A_WORKING_COPY if the cwd's not inside a working copy.
 */
void SG_cmd_util__get_repo_from_cwd(SG_context* pCtx, SG_repo** ppRepo, SG_pathname** ppPathCwd);

/**
 * "Throws" SG_ERR_NOT_A_WORKING_COPY if no --repo was specified and the cwd's not inside a working copy.
 */
void SG_cmd_util__get_descriptor_name_from_options_or_cwd(
	SG_context* pCtx, 
	SG_option_state* pOptSt, 
	SG_string** ppstrDescriptorName,
	SG_pathname** ppPathCwd);

/**
 * "Throws" SG_ERR_NOT_A_WORKING_COPY if no --repo was specified and the cwd's not inside a working copy.
 */
void SG_cmd_util__get_repo_from_options_or_cwd(SG_context* pCtx, SG_option_state* pOptSt, SG_repo** ppRepo, SG_pathname** ppPathCwd);

/**
 * "Throws" SG_ERR_NOT_A_WORKING_COPY if no --repo was specified and the cwd's not inside a working copy.
 */
void SG_cmd_util__get_branch_name_from_cwd(SG_context* pCtx, char** ppszBranchName);

/**
 * Get the parent changeset for the provided working copy.
 * "Throws" SG_ERR_CANNOT_DO_WHILE_UNCOMMITTED_MERGE if there's more than one parent.
 * ppPendingTree is optional--pass NULL if you don't want it.
 */
void SG_cmd_util__get_single_wd_parent(
	SG_context* pCtx, const 
	SG_pathname* pPathWorkingDir, 
	char** ppszHidParentCs, 
	SG_pendingtree** ppPendingTree);

void SG_cmd_util__dump_history_results(
	SG_context * pCtx, 
	SG_console_stream cs,
	SG_history_result* pHistResult, 
	SG_vhash* pvh_pile, 
	SG_bool bShowOnlyOpenBranchNames,
	SG_bool bShowFullComments,
	SG_bool bHideRevnums);

void SG_cmd_util__dump_log(
	SG_context * pCtx, 
	SG_console_stream cs,
	SG_repo* pRepo, 
	const char* psz_hid_cs, 
	SG_vhash* pvhCleanPileOfBranches, 
	SG_bool bShowOnlyOpenBranchNames,
	SG_bool bShowFullComments);

void SG_cmd_util__dump_log__revspec(
	SG_context * pCtx, 
	SG_console_stream cs,
	SG_repo* pRepo, 
	SG_rev_spec* pRevSpec, 
	SG_vhash* pvhCleanPileOfBranches, 
	SG_bool bShowOnlyOpenBranchNames,
	SG_bool bShowFullComments);

void SG_cmd_util__get_comment_from_editor(
	SG_context* pCtx, 
	SG_string *pstrBoilerplate,
	char** ppszComment,
	const SG_varray *descs);

void SG_cmd_util__build_comment_boilerplate(
	SG_context* pCtx, 
	SG_bool bForCommit,
	SG_uint32 count_args, const char ** paszArgs, 
	SG_option_state* pOptSt, 
	SG_string** ppstrBoilerplate);

