If no subcommand is used, the behavior is equivalent to `list --interactive`.

FILENAME
========

Specifying a filename instead of a subcommand is just a more convenient way of invoking
an interactive resolve prompt on a single file.

list
====

Use this command to review conflicts that exist in the working copy.
If a filename is specified, only conflicts on that file are listed.

next
====

Use this command to review the next unresolved conflict in the working copy.
If a filename is specified, the next unresolved conflict on that file is listed.

accept
======

Use of either [FILENAME] or --all is required.

To specify a resolution value, use its 'label', not the value itself. Valid labels include:
* 'ancestor' (the value from the merge's common ancestor changeset)
* 'baseline' (the value from the working copy's original parent)
* 'other' (the value from the changeset merged into the working copy)
* 'working' (the value as it currently exists in the working copy)

For example, if the `baseline' value on a 'name' conflict is 'file.txt`, the label would be
specified as 'baseline', not 'file.txt'.

To specify a conflict on a file that has several conflicts, use one of the
following values for the 'CONFLICT' parameter:
* 'existence'
* 'name'
* 'location'
* 'attrs'
* 'xattrs'
* 'contents'

diff
====

This command may only be used on `contents` conflicts on standard files.

To specify a resolution value, use its 'label', not the value itself. Valid labels include:
* 'ancestor' (the value from the merge's common ancestor changeset)
* 'baseline' (the value from the working copy's original parent)
* 'other' (the value from the changeset merged into the working copy)
* 'working' (the value as it currently exists in the working copy)

For example, if the `baseline' value on a 'name' conflict is 'file.txt`, the label would be
specified as 'baseline', not 'file.txt'.

To specify a conflict on a file that has several conflicts, use one of the
following values for the 'CONFLICT' parameter:
* 'existence'
* 'name'
* 'location'
* 'attrs'
* 'xattrs'
* 'contents'

merge
=====

This command may only be used on `contents` conflicts on standard files.

To specify a resolution value, use its 'label', not the value itself. Valid labels include:
* 'ancestor' (the value from the merge's common ancestor changeset)
* 'baseline' (the value from the working copy's original parent)
* 'other' (the value from the changeset merged into the working copy)
* 'working' (the value as it currently exists in the working copy)

For example, if the `baseline' value on a 'name' conflict is 'file.txt`, the label would be
specified as 'baseline', not 'file.txt'.

To specify a conflict on a file that has several conflicts, use one of the
following values for the 'CONFLICT' parameter:
* 'existence'
* 'name'
* 'location'
* 'attrs'
* 'xattrs'
* 'contents'
