/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

load("vscript_test_lib.js");

//////////////////////////////////////////////////////////////////
// Test COMMIT of a DELETED item by name when the item is within
// a DELETED directory.
//////////////////////////////////////////////////////////////////

function st_remove_deleted__SPRAWL_826()
{
    load("update_helpers.js");          // load the helper functions
    initialize_update_helpers(this);    // initialize helper functions

    load("update_submodule_helpers.js");
    initialize_update_submodule_helpers(this);

    //////////////////////////////////////////////////////////////////

    this.test_1 = function()
    {
	this.force_clean_WD();

	this.do_fsobj_mkdir("dir_A");
	this.do_fsobj_mkdir("dir_A/dir_B");
	this.do_fsobj_mkdir("dir_A/dir_B/dir_C");
        this.do_fsobj_create_file("dir_A/dir_B/dir_C/file_1");
        this.do_fsobj_create_file("file_2");
        this.do_fsobj_create_file("file_3");
        this.do_fsobj_create_file("file_4");
        this.do_fsobj_create_file("file_5");
	this.do_addremove_scan();
	this.do_commit("add initial files");
	var cset_base = sg.pending_tree.parents()[0];

	//////////////////////////////////////////////////////////////////
	print("");
	print("//////////////////////////////////////////////////////////////////");
	print("Deleting something....");
	print("");

	this.do_vc_remove_file("dir_A/dir_B/dir_C/file_1");
	this.do_vc_remove_dir("dir_A/dir_B/dir_C");
	this.do_vc_remove_file("file_2");
	this.do_vc_remove_file("file_3");

        var expect_test = new Array;
	expect_test["Removed"] = [ "@/dir_A/dir_B/dir_C/file_1",
				   "@/dir_A/dir_B/dir_C",
				   "@/file_2",
				   "@/file_3"
				 ];
        this.confirm_when_ignoring_ignores(expect_test);

	testlib.ok( (sg.fs.exists("dir_A/dir_B/dir_C/file_1")==false), "dir_A/dir_B/dir_C/file_1 should not exist.");
	testlib.ok( (sg.fs.exists("dir_A/dir_B/dir_C")==false),        "dir_A/dir_B/dir_C should not exist.");

	//////////////////////////////////////////////////////////////////
	print("");
	print("//////////////////////////////////////////////////////////////////");
	print("Commit one deleted file by name....");
	print("");

	var result = sg.exec(vv, "commit", "-m", "commit_the_delete", "dir_A/dir_B/dir_C/file_1");

	testlib.ok( (result.exit_status == 0), "'vv commit file_1' should pass" );
	if (result.exit_status != 0)
	    print(dumpObj(result, "Error from Commit", "", 0));

        var expect_test = new Array;
// currently the above COMMIT commits both file_1 and dir_C.
// i think it should only be file_1.  this is addressed in sprawl-819.
// when that is fixed, update the expected results here.
//	expect_test["Removed"] = [ "@/dir_A/dir_B/dir_C",
//				   "@/file_2",
//				   "@/file_3"
//				 ];
	expect_test["Removed"] = [ 
				   "@/file_2",
				   "@/file_3"
				 ];
        this.confirm_when_ignoring_ignores(expect_test);

    }

}
