/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

load("vscript_test_lib.js");

//////////////////////////////////////////////////////////////////
// REVERT tests:
//     vv add file
//     delete it (without using vv)
//     try to 'vv revert' it by name (not --all)
//////////////////////////////////////////////////////////////////

function st_revert__unadd_deleted__R9203()
{
    load("update_helpers.js");          // load the helper functions
    initialize_update_helpers(this);    // initialize helper functions

    //////////////////////////////////////////////////////////////////

    this.test_1 = function()
    {
	this.force_clean_WD();

        this.do_fsobj_mkdir("dir_A");
        this.do_fsobj_create_file("file_0");
        this.do_addremove_scan();

        var expect_test = new Array;
	expect_test["Added"] = [ "@/dir_A",
				 "@/file_0" ];
        this.confirm_when_ignoring_ignores(expect_test);

	//////////////////////////////////////////////////////////////////
	print("");
	print("//////////////////////////////////////////////////////////////////");
	print("Delete items without using vv...");
	print("");

	this.do_fsobj_remove_file("file_0");
	this.do_fsobj_remove_dir("dir_A");

        var expect_test = new Array;
	expect_test["Lost"] = [ "@/dir_A",
				 "@/file_0" ];
        this.confirm_when_ignoring_ignores(expect_test);

	//////////////////////////////////////////////////////////////////
	print("");
	print("//////////////////////////////////////////////////////////////////");
	print("Starting REVERT dir_A by name");
	print("");

	this.vv_revert_verbose1( "unadd_deleted", "dir_A" );

        var expect_test = new Array;
	expect_test["Lost"] = [ "@/file_0" ];
        this.confirm_when_ignoring_ignores(expect_test);

	//////////////////////////////////////////////////////////////////
	print("");
	print("//////////////////////////////////////////////////////////////////");
	print("Starting REVERT file_0 by name");
	print("");

	this.vv_revert_verbose1( "unadd_deleted", "file_0" );

        var expect_test = new Array;
        this.confirm_when_ignoring_ignores(expect_test);
    }

    this.test_2 = function()
    {
	this.force_clean_WD();

        this.do_fsobj_mkdir("dir_A");
        this.do_fsobj_create_file("file_0");
        this.do_addremove_scan();

        var expect_test = new Array;
	expect_test["Added"] = [ "@/dir_A",
				 "@/file_0" ];
        this.confirm_when_ignoring_ignores(expect_test);

	//////////////////////////////////////////////////////////////////
	print("");
	print("//////////////////////////////////////////////////////////////////");
	print("Delete items without using vv...");
	print("");

	this.do_fsobj_remove_file("file_0");
	this.do_fsobj_remove_dir("dir_A");

        var expect_test = new Array;
	expect_test["Lost"] = [ "@/dir_A",
				 "@/file_0" ];
        this.confirm_when_ignoring_ignores(expect_test);

	//////////////////////////////////////////////////////////////////
	print("");
	print("//////////////////////////////////////////////////////////////////");
	print("Starting REVERT --all");
	print("");

	this.vv_revert_verbose( "unadd_deleted" );

        var expect_test = new Array;
        this.confirm_when_ignoring_ignores(expect_test);
    }
}
