/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

function vv_serve_process(port, runFromWorkingFolder) {
	this.port = port.toString();

	sg.fs.cd(repInfo.workingPath);
	if (!runFromWorkingFolder)
		sg.fs.cd("..");

	sg.set_local_setting("server/enable_diagnostics", "true");

	if (sg.config.debug) {
		var pathPrefix = ".";
		if (runFromWorkingFolder)
			pathPrefix = "..";

		this.stdoutfilepath = pathPrefix + "/serve-" + this.port + "-stdout.txt";
		this.stderrfilepath = pathPrefix + "/serve-" + this.port + "-stderr.txt";
		print("Starting server on port " + port);
		this.pid = sg.exec_nowait(["output=" + this.stdoutfilepath, "error=" + this.stderrfilepath],
		                          "vv", "serve", "--port=" + this.port);
	}
	else
		this.pid = sg.exec_nowait("vv", "serve", "--port=" + this.port);

	sg.fs.cd(repInfo.workingPath);

	sleep(5000); // Give it some time to start up before we start hitting it with requests.

	this.stop = function () {
		print ("In vv_serve_process.stop()");
		
		sg.set_local_setting("server/enable_diagnostics", "");
	
		if (sg.config.debug) {
			sg.exec("curl", "-d", "{\"test\":true}", "http://localhost:" + this.port + "/test/remote-shutdown");
			
			// Print server's output so that its memleaks will be caught.
			print("(Giving 'vv serve' some time to shut down before we print its stdout/stderr output...)")
			sleep(30000);
			sg.fs.cd(repInfo.workingPath);
			if (!runFromWorkingFolder)
				sg.fs.cd("..");
			print();
			print(sg.file.read(this.stdoutfilepath));
			print();
			print(sg.file.read(this.stderrfilepath));
		}
		else {
			// Just kill the server.
			if (sg.platform() == "WINDOWS")
				sg.exec("taskkill", "/PID", this.pid.toString(), "/F");
			else
				sg.exec("kill", "-s", "SIGINT", this.pid.toString());
			sleep(5000);
		}
	}
}
