/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 * @file sg_clone_prototypes.h
 */

#ifndef H_SG_CLONE_PROTOTYPES_H
#define H_SG_CLONE_PROTOTYPES_H

BEGIN_EXTERN_C;

void SG_clone__exact(
	SG_context* pCtx,
    const char* psz_existing,
    const char* psz_new
    );

void SG_clone__create(
	SG_context* pCtx,
    const char* psz_existing,
	SG_clone** ppClone
    );

void SG_clone__cleanup(
    SG_context* pCtx,
    SG_clone** ppClone
    );

void SG_clone__init_demands(
	SG_context* pCtx,
    struct SG_clone__demands* p_demands
    );

void SG_clone__commit(
	SG_context* pCtx,
	SG_clone* pClone,
    const char* psz_new_repo,
    SG_vhash* pvh_changes,
    struct SG_clone__params__all_to_something* pats,
    struct SG_clone__demands* p_demands
    );

void SG_clone__pack(
    SG_context* pCtx,
    const char* psz_existing,
    const char* psz_new,
    SG_int32 nKeyframeDensity,
    SG_int32 nRevisionsToLeaveFull,
    SG_uint32 nMinRevisions,
    SG_uint64 low_pass,
    SG_uint64 high_pass,
    struct SG_clone__demands* p_demands
    );

void SG_clone__all_to_something(
    SG_context* pCtx,
    const char* psz_existing,
    const char* psz_new,
    struct SG_clone__params__all_to_something* pats,
    struct SG_clone__demands* p_demands
    );

END_EXTERN_C;

#endif

