/*
Copyright 2010 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

//////////////////////////////////////////////////////////////////

#ifndef H_SG_FILE_SPEC__LOAD_RESERVED_H
#define H_SG_FILE_SPEC__LOAD_RESERVED_H

BEGIN_EXTERN_C;

//////////////////////////////////////////////////////////////////

void SG_file_spec__load_reserved(
	SG_context*   pCtx,
	SG_file_spec* pThis
	)
{
	const char * pszDrawerDirectoryName = NULL;

	SG_NULLARGCHECK(pThis);

	SG_ERR_CHECK(  SG_workingdir__get_drawer_directory_name(pCtx, &pszDrawerDirectoryName)  );

	SG_ERR_CHECK(  SG_file_spec__add_pattern__sz(pCtx,
												 pThis,
												 SG_FILE_SPEC__PATTERN__RESERVE,
												 pszDrawerDirectoryName,
												 ( SG_FILE_SPEC__MATCH_FOLDERS_RECURSIVELY
												   | SG_FILE_SPEC__MATCH_ANYWHERE))  );

fail:
	return;
}

//////////////////////////////////////////////////////////////////

END_EXTERN_C;

#endif//H_SG_FILE_SPEC__LOAD_RESERVED_H
