/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

function getStatus()
{

	var ctr = $('#maincontent');
	$('#fsLoading .statusText').text("Geting Working Copy Status...");
	$('#fsLoading').show();

	vCore.ajax(
		{
		    url: "/local/status.json",
		    dataType: 'json',

		    error: function (xhr, textStatus, errorThrown)
		    {
		        $('#fsLoading').hide();
		    },

		    success: function (data)
		    {

		        $('#fsLoading').hide();

		        if (isEmpty(data.status))
		        {
		            var div = $('<p>').width(300).height(30);
		            div.text("no changes in your working copy");
		            div.addClass("highlight");

		            ctr.append(div);
		            return;
		        }

		        var ul = $("<ul>").addClass("cslist");
		        $.each(data.status, function (index, value)
		        {
		            $.each(value, function (ii, vv)
		            {
		                var li = $(document.createElement("li"));

		                if (index == "Modified")
		                {
		                    var diffURL = sgCurrentRepoUrl
								+ "/diff_local.json?hid1="
								+ vv.old_hid
								+ "&path="
								+ vv.path;

		                    var imgd = $('<img>').attr("src", sgStaticLinkRoot + "/img/diff.png");

		                    var a_diff = $('<a>').html(imgd);
		                    a_diff.attr(
									{
									    href: "#",
									    'title': "diff against current working copy"
									});
		                    a_diff.addClass("download_link");
		                    a_diff.click(function (e)
		                    {
		                        e.preventDefault();
		                        e.stopPropagation();
		                        showDiff(diffURL, $('<div>'), true);
		                    });
		                    var a_view = $('<a>').text(vv.path);
		                    a_view.attr(
									{
									    href: "#",
									    'title': "view current working copy"
									});
		                    a_view.click(
									function (e)
									{
									    var tmpPath = vv.path.ltrim("@/");
									   
									    displayLocalFile(tmpPath);
									});
		                    li.append(a_view);
		                    li.append(a_diff);
		                }
		                else
		                    li.text(vv.path);

		                li.prepend(index + " ");
		                ul.append(li);
		            });
		        });

		        ctr.append(ul);
		    }
		});
}

function sgKickoff()
{
	getStatus();
}