/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

var _menuWorkItemHover = null; 
var _lastVvHeartbeat = 0;
var noRepo = false;
var gotRepos = false;
var $aboutdialog = null;

function menuSetup()
{
    var faMenu = $('#menufilteractivity');

    if (_showActivity())
    {
        $('#menushowactvity').addClass("checked");
    }
    else
    {
        $('#menushowactvity').removeClass("checked");
        faMenu.hide();
    }

    if (_filterActivity())
        faMenu.addClass('checked');
    else
        faMenu.removeClass('checked');

    $(".menudropdownsub").click(
    function (e)
    {
        var sub = $(this).parent().find("ul");

        sub.css({ "min-width": Math.max($(this).parent().width(), sub.width()) });
        if ($(this).parent().hasClass("open"))
        {
            var sub = $(this).parent().find("ul.submenu");
            sub.hide();
            $(this).parent().removeClass("open");
        }
        else
        {
            $(this).parent().addClass("open");
            sub.slideDown('fast');

            $(document).mouseup($(this), function (e)
            {
                if ($("li.menudropdown").hasClass("open"))
                {
                    e.stopPropagation();
                    if (!$(e.target).hasClass("submenuli") && !$(e.target).hasClass("menulink") && !$(e.target).hasClass("imgmenudropdown")
                        && !$(e.target).hasClass("menudropdown") && !$(e.target).hasClass("menudropdownsub"))
                    {
                        $("ul.submenu").hide();
                        $("li.menudropdown").removeClass("open");

                        return false;
                    }
                    else if ($(e.target).hasClass("menudropdownsub"))
                    {
                        var menus = $("li.menudropdown.open");
                        $.each(menus, function (i, v)
                        {
                            if ($(v).attr("id") != $(e.target).parent().attr("id"))
                            {
                                $(v).find("ul.submenu").hide();
                                $(v).removeClass("open");
                            }
                        });
                    }
                }

            });

        }
    });

    if (sgLocalRepo && sgLocalRepo == startRepo)
    {
        $("#menu_local_status").show();
        $("#menu_local_fs").show();
    }
    
}

function _setupAbout()
{
    $aboutdialog = $('<div>')
	.dialog({
	    position: [$(window).width() - 250, $('#menuabout').position().top + 20],
	    buttons:
		{
		    "ok": function ()
		    {
		        $(this).dialog("close");
		    }
		},
	    autoOpen: false,
	    title: 'about sourcegear veracity',
        resizable: false
	});

}
function _menuShowAbout(e)
{
    e.preventDefault();
    $aboutdialog.dialog("open");
	vCore.ajax(
		{
			type: "GET",
			url: sgLinkRoot + "/version.txt",

			success: function (data, status, xhr)
			{
				$aboutdialog.html("<div>version: " + data + "</div>");			
			}

		}
	);

}

function _menuShowHideActivity()
{
	if (_showActivity())
	{
		hideActivity();
		_setShowActivity(false);      

	}
	else
	{
		displayActivity();
		_setShowActivity(true);
		listActivity();
	}
}

function _menuToggleFilterActivity()
{
	if (_filterActivity())
	{
		_filterActivity(false);
	}
	else
	{
		_filterActivity(true);
	}

	if (_showActivity())
	listActivity();
}

function _menuClearSearch(e)
{
    e.preventDefault();
    e.stopPropagation();
    $('#textmenusearch').categorycomplete("close");
    $('#textmenusearch').categorycomplete("clearTerm");
	$('#textmenusearch').val("");
	
	$('#textmenusearch').removeClass("ui-autocomplete-loading");
	//todo cancel request??
}


$.widget("custom.categorycomplete", $.ui.autocomplete,
{
    fromEnter: false,
    ajaxRequest: null,

    setEnter: function (value)
    {
        this.fromEnter = value;
    },
    clearTerm: function ()
    {
        this.term = "";
        if (this.ajaxRequest)
        {
            this.ajaxRequest.abort();
        }
    },
    _renderMenu: function (ul, items)
    {
        var self = this;
        var currentCategory = "";
        $.each(items, function (index, item)
        {
            if (item.category != "more" && item.category != "none" && item.category != currentCategory)
            {
                ul.append("<li class='ui-autocomplete-category'>" + item.category + "</li>");
                currentCategory = item.category;
            }
            self._renderItem(ul, item);
        });
    },
    _renderItem: function (ul, item)
    {
        var li = $("<li></li>")
			.data("item.autocomplete", item)
            .appendTo(ul);

        if (item.category == "none")
        {
            li.text(item.label);
        }
        else
        {
            li.append($("<a></a>").text(item.label));
        }
        return li;
    }

});


function _setUpSearch()
{
    $('#textmenusearch').keyup(function (e1)
    {
        if (e1.which == 13)
        {
            e1.preventDefault();
            e1.stopPropagation();

            $(this).categorycomplete("setEnter", true);
            $(this).categorycomplete("search");
        }
    });
    $("#menuSearchAdvanced").click(function (e)
    {
        if ($('#textmenusearch').val())
        {
            // e.preventDefault();
            // e.stopPropagation();           

            var url = sgCurrentRepoUrl + "/search.html?areas=wit,vc,builds";

            url += "&text=" + encodeURIComponent($('#textmenusearch').val());
            $("#menuSearchAdvanced").attr("href", url);

        }
    });

    $('#textmenusearch').categorycomplete({

        source: function (request, response)
        {
            var self = this;

            vCore.ajax({
                url: sgCurrentRepoUrl + "/searchresults.json?text=" + encodeURIComponent(request.term),

                beforeSend: function (jqXHR)
                {
                    var pending = self.pending;
                    if (self.ajaxRequest)
                    {
                        pending--;
                        self.pending = Math.max(pending, 0);
                        self.ajaxRequest.abort();
                    }
                    self.ajaxRequest = jqXHR;
                },
                success: function (data)
                {
                    if (data.error)
                    {
                        reportError("invalid input - " + data.error);

                        $('#textmenusearch').removeClass("ui-autocomplete-loading");
                        return;
                    }
                    var items = [];
                    var inList = {};
                    $.each(data.items, function (i, v)
                    {
                        if (!inList[v.id])
                        {
                            items.push(v);
                            inList[v.id] = v;
                        }
                    });


                    if (self.fromEnter)
                    {
                        if (items.length == 1)
                        {
                            if (items[0].category == "changesets")
                            {
                                url = sgCurrentRepoUrl + "/changeset.html?recid=" + items[0].id;
                            }
                            else if (items[0].category == "builds")
                            {
                                url = sgCurrentRepoUrl + "/build.html?recid=" + items[0].id;
                            }
                            else if (items[0].category == "work items")
                            {
                                url = sgCurrentRepoUrl + "/workitem.html?recid=" + items[0].id;
                            }
                            document.location.href = url;
                            self.fromEnter = false;
                            return;
                        }

                    }
                    var lastResult = null;
                    if (!items.length)
                    {
                        lastResult =
                        {
                            name: "no results",
                            category: "none"
                        };
                    }
                    else if (data.more)
                    {
                        lastResult =
                        {
                            name: "more results...",
                            category: "more"
                        };
                    }
                    else
                    {
                        lastResult =
                        {
                            name: "detailed results...",
                            category: "more"
                        };
                    }
                    items.push(lastResult);

                    response($.map(items, function (item)
                    {
                        if (item.category == "builds")
                        {
                            var d = new Date(parseInt(item.extra));
                            var dateStr = d.strftime("%Y/%m/%d %H:%M%P");
                            return { label: item.name + " - " + dateStr + " - " + item.description, value: item.name, id: item.id, category: item.category };

                        }
                        else if (item.category == "more" || item.category == "none")
                        {
                            return { label: item.name, category: item.category, id: request.term };
                        }
                        else
                        {
                            return { label: item.name + " - " + item.extra + " - " + item.description, value: item.name, id: item.id, category: item.category };

                        }
                    }));
                    self.fromEnter = false;
                }
            });
        },
        minLength: 2,
        select: function (event, ui)
        {
            var url = "";
            if (ui.item)
            {
                if (ui.item.category == "changesets")
                {
                    url = sgCurrentRepoUrl + "/changeset.html?recid=" + encodeURIComponent(ui.item.id);
                }
                else if (ui.item.category == "more")
                {
                    url = sgCurrentRepoUrl + "/search.html?text=" + encodeURIComponent(ui.item.id) + "&areas=wit,vc,builds";
                }
                else if (ui.item.category == "builds")
                {
                    url = sgCurrentRepoUrl + "/build.html?recid=" + encodeURIComponent(ui.item.id);
                }
                else
                {
                    url = sgCurrentRepoUrl + "/workitem.html?recid=" + encodeURIComponent(ui.item.id);
                }
                document.location.href = url;
            }
        },
        delay: 1000,
        position:
			{
			    my: "right top",
			    at: "right bottom"
			},
        appendTo: "#divSearchArea"

    }
	);
}

function _visitedFilters()
{
	var cname = vCore.getDefaultCookieName();
	return vCore.getCookieValueForKey(cname, "visitedFilters", []);
}

function _findFilter(filters, recid)
{
	for (var i=0; i<filters.length; i++)
	{
		if (filters[i].recid == recid)
		{
			return { index: i, filter: filters[i] };
		}
	}
	return null;
}

function _saveVisitedFilter(name, recid)
{
    var cname = vCore.getDefaultCookieName();    
	var visited = _visitedFilters();
	var items = [];
	var ap = null;
	if (visited)
	{
		ap = _findFilter(visited, recid);
		if (!ap && visited.length > 9)
		{
			visited.pop();
		}

		if (ap)
		{
			visited.splice(ap.index, 1);
		}
	}
	visited.unshift({"name": name, "recid": recid});
	vCore.setCookieValueForKey(cname, "visitedFilters", visited, 30);
	_setFilterMenu();
}

function _createFilterMenuList(data)
{
	var ul = $("#filtersmenu");
	$('#filtersmenu li').remove();

	var liList = [];
	$.each(data, function (i, v)
	{
	    if (i < 10)
	    {
	        var add = false;
	        var addCount = 0;
	        var li = $("<li>").addClass("submenuli");
	        var a = $("<a>").text(v.name).attr({ href: sgCurrentRepoUrl + "/workitems.html?filter=" + v.recid });
	        a.addClass("menulink");
	        li.append(a);

	        ul.append(li);
	    }
	});

	//we need to do this after the filter menu has been created
	//so all of the events get bound
	_bindLiClickEvents($(document));

}

function _deleteFromFiltersMenu(recid, afterDeleteFunction)
{
    var cname = vCore.getDefaultCookieName();
    var visited = _visitedFilters();

    var ap = null;
    if (visited)
    {
        ap = _findFilter(visited, recid);

        if (ap)
        {
            visited.splice(ap.index, 1);
        }

        //fetch more saved filter values so we always have
        //10 items in the menu
        if (visited.length < 10)
        {
            var count = visited.length;
            vCore.fetchFilters(
            {
                max: 10,
                success: function (data)
                {
                    for (var i in data)
                    {
                        if (!_findFilter(visited, data[i].recid))
                        {
                            _saveVisitedFilter(data[i].name, data[i].recid);

                            if (count++ == 10)
                                break;
                        }
                    }
                    if (afterDeleteFunction)
                        afterDeleteFunction();
                }
            });
        }
        else
        {
            if (afterDeleteFunction)
                afterDeleteFunction();
        }
    }
    vCore.setCookieValueForKey(cname, "visitedFilters", visited, 30);
    _setFilterMenu();
   
}

function _addFiltersToMenu(data)
{
	$.each(data, function (i, v)
	{
		if (i < 10)
		{
			_saveVisitedFilter(v.name, v.recid);
		}
	});

	_createFilterMenuList(data);
}

function _setFilterMenu(forceRefresh)
{
	var visited = _visitedFilters();
	var items = [];

	if (sgUserName && sgUserName.length > 0)
	{
		$("#menumanagefilters").show();
		if (!forceRefresh && (visited && visited.length > 0))
		{
			_createFilterMenuList(visited);
		}
		else
		{
		    if (forceRefresh)
		    {
		        //clear saved filter cookie
		        var cname = vCore.getDefaultCookieName();
		        vCore.setCookieValueForKey(cname, 'visitedFilters', [], 30);
		    }       
			vCore.fetchFilters({ max: 10, success: _addFiltersToMenu });
		}
	}
}

var sgFilterResultsCookie = "sgfilterresults";
var sgQueryResultsCookie = "sglastquery";


function _saveLastQueryCookie(value)
{
    vCore.setCookie(sgQueryResultsCookie, '', -1);
    vCore.setCookie(sgQueryResultsCookie, value, 1);
}

function _getLastQueryCookie()
{
	return _findCookie(sgQueryResultsCookie);  
}

function _saveQueryResultIds(value)
{
    vCore.setCookie(sgFilterResultsCookie, '', -1);
    vCore.setCookie(sgFilterResultsCookie, value, 1);
}

function _getLastResultIds()
{
	var results = _findCookie(sgFilterResultsCookie);
	if (results)
	{
		return $.parseJSON(results);
	}
	return null;  
}

function _visitedItems()
{
	var cname = vCore.getDefaultCookieName();
	return vCore.getCookieValueForKey(cname, "visitedItems", []);
}


function _displayLastVisitedItems()
{
	var cookie = _visitedItems();

	if (cookie)
	{
	    $.each(cookie, function (i, v)
	    {
	        var nv = v.split(":");
	        var li = $("<li>").attr("id", nv[1]).addClass("submenuli");
	        var a = $("<a>").text(nv[0]).attr({ href: sgCurrentRepoUrl + "/workitem.html?recid=" + nv[1] });
	        a.addClass("menulink");

	        li.append(a);
	        $("#visitedmenu").append(li);
	        _menuWorkItemHover.addHover(li, nv[1]);	     

	    });      
	}

}

function _saveVisitedItem(id, recid)
{
	var cname = vCore.getDefaultCookieName();
	var visited = _visitedItems();
	if (visited && visited.length > 5)
	{
		visited.pop();
	}

	var newItem = id + ":" + recid;
	if ($.inArray(newItem, visited) < 0)
	{
		visited.unshift(newItem);
		vCore.setCookieValueForKey(cname, "visitedItems", visited, 30);
	}
	$("#visitedmenu").find("li").remove();
	_displayLastVisitedItems();
}



function _findCurrentSprint()
{
	var url = sgCurrentRepoUrl + "/config/current_sprint";

	vCore.ajax(
		{
			type: "GET",
			url: url,
			success: function (data, status, xhr)
			{
				sgCurrentSprint = data.value;
			}

		}
	);
}

var visitedRepoCookieName = "sgVisitedRepos";

function deleteFromRepoMenu(reponame, afterDelete)
{
    var visited = vCore.getJSONCookie(visitedRepoCookieName);
    if (!visited)
        visited = [];

    if (visited && visited.length)
    {
        var pos = $.inArray(reponame, visited);
        if (pos >= 0)
        {
            visited.splice(pos, 1);
        }
    }
    vCore.setCookie(visitedRepoCookieName, JSON.stringify(visited), 30);
    _displayLastVisitedRepos(afterDelete);
}
function _saveVisitedRepo(reponame)
{
    var visited = vCore.getJSONCookie(visitedRepoCookieName);
    if (!visited)
        visited = [];
   
    if (visited && visited.length > 5)
    {
        visited.pop();
    }

    if ($.inArray(reponame, visited) < 0)
    {
        visited.unshift(reponame);       
    }
    vCore.setCookie(visitedRepoCookieName, JSON.stringify(visited), 30);

}

function _displayLastVisitedRepos(afterfunction)
{
    var visited = vCore.getJSONCookie(visitedRepoCookieName);
	
	if (visited)
	{
		if (!gotRepos)
		{
		    vCore.fetchRepos(
				{
				    success: function (data)
				    {
				        $.each(data, function (i, v)
				        {
				            if ($.inArray(v, visited) < 0 && visited.length < 6)
				            {
				                visited.push(v);
				            }
				        });

				        _setMenuRepos(visited);
				        if (afterfunction)
				        {
				            afterfunction();
				        }
				        gotRepos = true;
				    },
				    complete: menuSetup
				}
			);
		}
		else
		{
			_setMenuRepos(visited);
			menuSetup();
		}
	}
	else
	{
		vCore.fetchRepos({ success: _setMenuRepos, complete: menuSetup });  
	}
}

function _setMenuRepos(repos)
{
    $("#ulmenurepos").find("li").remove();

    if (repos.length > 1)
    {
        $('#menureposelector').addClass("menudropdown repos");

        var n = 0;

        $.each(repos, function (i, v)
        {
            if (v != startRepo && n < 6)
            {
                var url = sgLinkRoot + "/repos/" + v;
                var li = $("<li class='submenuli'></li>");
                var a = $("<a>").text(v).attr("href", url).addClass("menulink").appendTo(li);

                $("#ulmenurepos").append(li);
                n++;
            }
        });

        var li = $("<li>");
        var a = $("<a>").text("...").attr({ "href": sgLinkRoot + "/repos.html", "title": "view all repositories" }).addClass("menulink");
        li.append(a).addClass("submenuli");

        $("#ulmenurepos").append(li);
    }
	
	$('<span></span>').text(repos[0]).prependTo($("#topMenuLiChooseRepo"));
    //we need to do this after the repos menu has been created
    //so all of the events get bound
    _bindLiClickEvents($("#ulmenurepos"));
    $("#verytop").show();

}

function _bindLiClickEvents(parentMenuObj)
{
    parentMenuObj.find(".submenuli:not(.local)").unbind("click");

    parentMenuObj.find(".submenuli:not(.local)").click(function (e)
    {
        if ($(e.target).attr("class") == "submenuli")
        {
            var a = $(this).find("a.menulink");
            if (a && a.length && $(a).attr("href") != "#")
            {
                window.location.href = $(a).attr("href");
            }
        }
    });
}

function _vvheartbeat()
{   
	vCore.ajax(
		{
			url: sgCurrentRepoUrl + "/heartbeat.json",
			reportErrors: false,
            no_ui: true,
			complete: function()
			{			   
				window.setTimeout(_vvheartbeat, 3000);
			},

			error: function(xhr, status, errorthrown)
			{
				// shit hit the fan
				$('#vvoffline').show();
			},
			
			success: function()
			{
				_lastVvHeartbeat = new Date();
				$('#vvoffline').hide();
			}
		}
	);
}

function _startHeartBeat()
{
	if (sgCurrentRepoUrl)
	{
		var h = new hoverControl(
			function(dummy, div)
			{
				div.empty();
				var p = $('<p></p>').
					text("Unable to contact the server at " + sgCurrentRepoUrl + ".").
					appendTo(div);

				if (_lastVvHeartbeat)
				{
					p = $('<p></p>').
						text("The server was last successfully contacted at " + vCore.formatDate(_lastVvHeartbeat, '%Y-%m-%d %H:%M:%S')).
						appendTo(div);
				}
			}
		);
		h.addHover($('#vvoffline'), 'dummy', 20, 0);
		window.setTimeout(_vvheartbeat, 3000);
	}
}

$(document).ready(function ()
{
    _setupAbout();
    $("#liMenuAbout").click(_menuShowAbout);
    $("#menushowactvity").click(_menuShowHideActivity);
    $("#menufilteractivity").click(_menuToggleFilterActivity);
    _setUpSearch();
    _menuWorkItemHover = new hoverControl(fetchWorkItemHover);
    if (sgUserName && sgUserName.length > 0 && sgUserName != "undefined")
    {
        _displayLastVisitedItems();
        _setFilterMenu();

        $("#topmenu").show();
        $("#menushowactvity").show();
        $("#settingsmenumilestones").show();
        $("#settingsmenubuilds").show();
        $("#identity").show();
    }
    else
    {
        $("#useremail").text("(not logged in)");
    }
    if (!noRepo)
    {
        _saveVisitedRepo(startRepo);
    }
    _displayLastVisitedRepos();
	_startHeartBeat();
    vCore.setMenuHeight();

    $("#menuclosesearch").click(_menuClearSearch);
});

//
//context menus
//
var highlightedRow = null;
var mouseOverRow = null;
function enableRowHovers(preventCtxMenu)
{
    $("table.datatable tr").unbind("mouseover");
    $("table.datatable tr").unbind("mouseout");

    $("table.datatable tr:not(.filtersectionheader)").bind("mouseover", function ()
    {
        highlightedRow = $(this);
        $(this).css("background-color", "#E4F0CE");
        if (preventCtxMenu !== true && !isTouchDevice())
            $(this).find("span.linkSpan").first().show();
    });

    $("table.datatable tr:not(.filtersectionheader)").bind("mouseout", function ()
    {
        $(this).css("background-color", "white");
        if (preventCtxMenu !== true && !isTouchDevice())
            $(this).find("span.linkSpan").first().hide();
    });

    if (highlightedRow != null)
        highlightedRow.mouseout();
    if (mouseOverRow != null)
        mouseOverRow.mouseover();

    if (preventCtxMenu === true)
        $("table.datatable tr").find("span.linkSpan").first().hide();
}

function disableRowHovers()
{
	$("table.datatable tr").unbind("mouseover");
	$("table.datatable tr").unbind("mouseout");

	$("table.datatable tr").bind("mouseout", function ()
	{
		mouseOverRow = null;
	});
	$("table.datatable tr").bind("mouseover", function ()
	{
		mouseOverRow = $(this);
	});
}

//relativeToElementId - dom emelement to use to position context menu also used as default "recid" for menu data if optData
//                      isn't specified
//menuObj - the actual context menu, if not specified $("#editMenu") will be used
//optData - extra data needed in the form {"id":"value", "id2: "value2", etc} if nothing passed in will use relativeToElementId data
function showCtxMenu(relativeToElementId, menuObj, optData)
{
	var menu = menuObj || $("#editMenu");
	var el = $("#" + relativeToElementId);
	var pos = el.offset();
	var width = el.width();
	if (optData)
	{        
		menu.data(optData);
	}
	else
	{
		menu.data("recid", relativeToElementId);
	}

	menu.hide();

	menu.css(
		{
			"position": "absolute",
			"left": (pos.left + width) + "px",
			"top": pos.top + "px"
		}
	);

	disableRowHovers();

	$(document).mouseup(menu, function (e)
	{
		// e.preventDefault();
		e.stopPropagation();
		if (!$(e.target).hasClass("ctxMenuItem") && !$(e.target).hasClass("ctxMenuItemImg"))
		{
			$(document).unbind("mouseup");
			enableRowHovers();

	        menu.hide();
	        if ($("#delConfMenu"))
	        {
	            $("#delConfMenu").hide();
	        }
	        if ($(".filterContextSubmenu"))
	        {
	            $(".filterContextSubmenu").hide();
	        }
	        return false;
	    }

		return true;
	});

	menu.fadeIn();
}

function showDeleteSubMenu(recid)
{
	var menu = $("#delConfMenu");
	var el = $("#confirm_delete");
	var pos = el.offset();
	var width = el.outerWidth();

	menu.data("recid", recid);

	menu.hide();

	menu.css(
		{
			"position": "absolute",
			"left": (pos.left + width) + "px",
			"top": (pos.top - 1) + "px"
		}
	);

	menu.fadeIn();
}

function showContextSubMenu(recid, parent, menu)
{
    var pos = parent.offset();
    var width = parent.outerWidth();

    menu.data("recid", recid);

    menu.css(
		{
		    "position": "absolute",
		    "left": (pos.left + width) + "px",
		    "top": (pos.top - 1) + "px"
		}
	);

    menu.fadeIn();
}
