/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 */

function _savedEmail()
{
	var cname = vCore.getDefaultCookieName();
	return vCore.getCookieValueForKey(cname, "email", null);
}

function _savedUser()
{
	var cname = vCore.getDefaultCookieName();
	return vCore.getCookieValueForKey(cname, "uid", null);
}

function _saveUser(uid, email)
{
	var cookieName = vCore.getDefaultCookieName();

	sgUserName = uid;
	sgUserEmail = email;

	if (uid && email)
	{
		var obj = {
			"uid": uid,
			"email": email
		}
		
		vCore.setCookieValuesFromObject(cookieName, obj, 30);
	}
}

function _removeUserCookies()
{
    vCore.setCookie("sgfilterresults", '', -1);
    vCore.setCookie("sglastquery", '', -1);
    var cname = vCore.getDefaultCookieName();
    vCore.setCookie(cname, '', -1);
}


function _hookUserSelector() {
	var cname = vCore.getDefaultCookieName();
	var cookie = vCore.getJSONCookie(cname);
	
	if (!!cookie.email)
	{
		sgUserEmail = cookie.email;
		vCore.setOption("userEmail", sgUserEmail);
	}
	
	if (!!cookie.uid)
	{
		sgUserName = cookie.uid;
		vCore.setOption("userName", sgUserName);
	}
	
	var select = $('#userselection');
	select.val(sgUserName);

	$('#useremail').text(sgUserEmail);
	
	select.change(
		function (e)
		{
		    var email = $("#userselection option:selected").text();
		    //delete cookies for this user
		    _removeUserCookies();
		    _saveUser($(this).val(), email);
		    window.location.reload();
		}
	);
}

function _findSgUser()
{
	var cname = vCore.getDefaultCookieName();
	var cookie = vCore.getJSONCookie(cname);
	var sgUserName = null;

	if (!!cookie.uid && cookie.uid != "undefined")
	    sgUserName = cookie.uid;

	if (!!cookie.email && cookie.email != "undefined")
	    sgUserEmail = cookie.email;

	else if (sgUserName && sgUserEmail)
		_saveUser(sgUserName, sgUserEmail);

	if (!sgUserName)
	{
		var redirect = true;
		try {
			redirect = !CURRENT_PAGE_IS_HOME_PAGE;
		}
		catch (ex) {
			redirect = true;
		}
		if (redirect) {
			document.location.href = sgLinkRoot + "/repos/" + startRepo;
		}
	}
}

$(document).ready(_hookUserSelector);
