/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// VeracityContextMenu.h : Declaration of the CVeracityContextMenu

#pragma once
#include "VeracityTortoise_i.h"
#include "resource.h"       // main symbols
#include <comsvcs.h>
extern "C"{
#define BEGIN_EXTERN_C
#define END_EXTERN_C
#include "sg.h"
}

using namespace ATL;



// CVeracityContextMenu

class ATL_NO_VTABLE CVeracityContextMenu :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CVeracityContextMenu, &CLSID_VeracityContextMenu>,
	public IDispatchImpl<IVeracityContextMenu, &IID_IVeracityContextMenu, &LIBID_VeracityTortoiseLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IShellExtInit,
    public IContextMenu
{
public:
	CVeracityContextMenu()
	{
		m_pCtx = NULL;
		mp_selectedPaths = NULL;
	}

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
		if (mp_selectedPaths != NULL && m_pCtx != NULL)
			SG_STRINGARRAY_NULLFREE(m_pCtx, mp_selectedPaths);
		if (mp_contextMenuItems != NULL && m_pCtx != NULL)
			SG_RBTREE_NULLFREE(m_pCtx, mp_contextMenuItems);
		SG_CONTEXT_NULLFREE(m_pCtx);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_VERACITYCONTEXTMENU)

DECLARE_NOT_AGGREGATABLE(CVeracityContextMenu)

BEGIN_COM_MAP(CVeracityContextMenu)
	COM_INTERFACE_ENTRY(IVeracityContextMenu)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IShellExtInit)
    COM_INTERFACE_ENTRY(IContextMenu)
END_COM_MAP()

public:
    // IShellExtInit
    STDMETHODIMP Initialize(LPCITEMIDLIST, LPDATAOBJECT, HKEY);

    // IContextMenu
    STDMETHODIMP GetCommandString(UINT_PTR, UINT, UINT*, LPSTR, UINT);
    STDMETHODIMP InvokeCommand(LPCMINVOKECOMMANDINFO);
    STDMETHODIMP QueryContextMenu(HMENU, UINT, UINT, UINT, UINT);


protected:
	SG_context * m_pCtx;
	SG_stringarray * mp_selectedPaths;
	SG_rbtree * mp_contextMenuItems;
	void NotifyError(SG_context * pCtx);
// IVeracityContextMenu
public:
};

OBJECT_ENTRY_AUTO(__uuidof(VeracityContextMenu), CVeracityContextMenu)
