/*
Copyright 2010-2011 SourceGear, LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#ifndef VV_REVDETAILS_COMMAND_H
#define VV_REVDETAILS_COMMAND_H

#include "precompiled.h"
#include "vvCommand.h"


/**
 * A command that displays the revision details of a working folder.
 */
class vvRevDetailsCommand : public vvCommand
{
// construction
public:
	/**
	 * Default constructor.
	 */
	vvRevDetailsCommand();

// implementation
public:
	/**
	 * Usage: revdetails path1 [path2 ...]
	 * - pathN: A path containing the working folder to display the revdetails of.
	 *          All specified paths must be in the same working folder.
	 */
	virtual bool ParseArguments(
		const wxArrayString& cArguments
		);

	/**
	 * See base class description.
	 */
	virtual bool Init();

	/**
	 * See base class description.
	 */
	virtual class vvDialog* CreateDialog(
		wxWindow* wParent
		);

// member data
private:
	wxString         msWFPath;  //< The path to the working folder
	wxString              msRevID; //< The identifier of the revision we'll be loading.
	wxString		 msRepoName;
	class vvRevDetailsDialog* mwDialog; //< The dialog to used to display the revdetails.
};


#endif
