#include "precompiled.h"
#include <wx/notebook.h>
#include <wx/thread.h>
#include "vvRevisionLinkControl.h"
#include "vvVerbs.h"
#include "vvHistoryObjects.h"
#include "vvContext.h"
#include "vvSgHelpers.h"

vvRevisionLinkControl::vvRevisionLinkControl()
{
}

vvRevisionLinkControl::vvRevisionLinkControl(
	unsigned int nRevisionNum,
	wxString sRevisionHID,
	wxWindow*          pParent,
	wxWindowID         cId,
	const wxPoint&     cPosition,
	const wxSize&      cSize,
	long               iStyle,
	const wxValidator& cValidator
	) //: wxPanel(pParent, cId,cPosition, cSize, iStyle, wxT("Audit Details Control") )
{
	cId;
	cPosition;
	cSize;
	iStyle;
	cValidator;
	this->Create(pParent, cId, cPosition, cSize, iStyle, cValidator);
	m_revHID = sRevisionHID;
	wxBoxSizer * sizer = new wxBoxSizer(wxVERTICAL);
	wxStaticText * pST = new wxStaticText(this, wxID_ANY, "");
	m_pST = pST;
	pST->SetForegroundColour(wxColor("blue"));
	wxPanel::MSWSetTransparentBackground(true);
	wxFont font = pST->GetFont();
	font.SetUnderlined(true);
	pST->SetFont(font);
	sizer->Add(pST, 1, wxEXPAND);
	wxPanel::SetSizer(sizer);
	pST->Connect(wxEVT_LEFT_UP, wxMouseEventHandler(vvRevisionLinkControl::OnClick), NULL, this);
	pST->Connect(wxEVT_ENTER_WINDOW, wxMouseEventHandler(vvRevisionLinkControl::OnEnter), NULL, this);
	pST->Connect(wxEVT_LEAVE_WINDOW, wxMouseEventHandler(vvRevisionLinkControl::OnLeave), NULL, this);
	this->SetRevision(nRevisionNum, sRevisionHID);
}

bool vvRevisionLinkControl::Create(
	wxWindow*          pParent,
	wxWindowID         cId,
	const wxPoint&     cPosition,
	const wxSize&      cSize,
	long               iStyle,
	const wxValidator&  cValidator
	)
{
	cValidator;
	// create our parent
	if (!wxPanel::Create(pParent, cId, cPosition, cSize, iStyle))
	{
		return false;
	}
	
	// done
	return true;
}

void vvRevisionLinkControl::SetRevision(long nRevno, wxString& sChangesetHID)
{
	wxString numStr = wxString::Format("%d", (int)nRevno);
	m_revHID = sChangesetHID;
	m_pST->SetLabel(numStr + ":" + sChangesetHID.substr(0, 10) + "...");
}

void vvRevisionLinkControl::OnClick(wxMouseEvent& evt)
{
	//Fire an event that the parent can catch.
	//wxCommandEvent ev(newEVT_REVISION_LINK_CLICKED, GetId() );
	//ev.SetString(m_revHID);
	//ev.SetEventObject(this);
	//ev.ResumePropagation(wxEVENT_PROPAGATE_MAX);

	wxCommandEvent MyEvent( wxEVT_COMMAND_BUTTON_CLICKED ); // Keep it simple, don't give a specific event ID
	MyEvent.SetString(m_revHID);
	wxPostEvent(this, MyEvent); // This posts to ourselves: it'll be caught and sent to a different method
//wxPostEvent(pBar, MyEvent); // Posts to a different class, Bar, where pBar points to an instance of Bar

	//wxEvtHandler::AddPendingEvent(ev);
	//wxPostEvent(this->GetParent()->GetEventHandler(), ev);
	//this->ProcessEvent(ev);
	evt.Skip();
}

void vvRevisionLinkControl::OnEnter(wxMouseEvent& evt)
{
	wxWindow::SetCursor(wxCURSOR_HAND);
	evt.Skip();
}

void vvRevisionLinkControl::OnLeave(wxMouseEvent& evt)
{
	wxWindow::SetCursor(wxCURSOR_ARROW);
	evt.Skip();
}
IMPLEMENT_DYNAMIC_CLASS(vvRevisionLinkControl, wxPanel);
BEGIN_EVENT_TABLE(vvRevisionLinkControl, wxPanel)
	EVT_LEFT_UP(vvRevisionLinkControl::OnClick)
END_EVENT_TABLE()
