
#ifndef _VV_LISTVIEWCOMBOBOX_H_
#define _VV_LISTVIEWCOMBOBOX_H_
#include <wx/combo.h>
#include <wx/listctrl.h>

class vv_wxListViewComboPopup : //public wxListView,
                             public wxComboPopup,
							 public wxPanel
{
public:

    // Initialize member variables
    virtual void Init()
    {
        m_value = -1;
    }

    // Create popup control
    virtual bool Create(wxWindow* parent)
    {
		if (wxPanel::Create(parent,1,wxPoint(0,0),wxDefaultSize))
		{
		}
		else
			return false;
		wxBoxSizer * sizer = new wxBoxSizer(wxHORIZONTAL);
		wxString empty;
		m_listView = new wxListView(parent, 2, wxPoint(0,0), wxDefaultSize,  wxLC_REPORT | wxLC_SINGLE_SEL | wxLC_HRULES/* | wxLC_NO_HEADER */);
		sizer->Add(m_listView, 1, wxEXPAND);
		sizer->SetSizeHints(this);
		wxPanel::SetSizer(sizer);
		m_listView->Connect(wxEVT_KEY_UP, wxKeyEventHandler(vv_wxListViewComboPopup::OnKeyUp), NULL, this);
		return true;
    }

    // Return pointer to the created control
    virtual wxWindow *GetControl() { return this; }

	wxListView * GetListView() { return m_listView; }

    // Translate string into a list selection
    virtual void SetStringValue(const wxString& s)
    {
        int n = m_listView->FindItem(-1,s);
        if ( n >= 0 && n < m_listView->GetItemCount() )
		{
            //wxListView::Select(n, true);
			m_listView->SetItemState(n, wxLIST_STATE_FOCUSED |wxLIST_STATE_SELECTED, wxLIST_STATE_FOCUSED|wxLIST_STATE_SELECTED);
		}
		m_initialValue = s;
    }

    // Get list selection as a string
    virtual wxString GetStringValue() const
    {
        if ( m_value >= 0 )
            return m_listView->GetItemText(m_value);
        return m_initialValue;
    }

    // Do mouse hot-tracking (which is typical in list popups)
    void OnMouseMove(wxMouseEvent& event)
    {
		event;
		int unused;
		long index = m_listView->HitTest(event.GetPosition(), unused);
		if (index >= 0)
		{
			long previousSelection = m_listView->GetFirstSelected();
			if (previousSelection != index)
			{
				m_listView->Select(previousSelection, false);
				m_listView->SetItemState(index, wxLIST_STATE_FOCUSED |wxLIST_STATE_SELECTED, wxLIST_STATE_FOCUSED|wxLIST_STATE_SELECTED);
			}
		}
    }

    // On mouse left up, set the value and close the popup
    void OnMouseClick(wxMouseEvent& event)
    {
		int unused;
		long index = m_listView->HitTest(event.GetPosition(), unused);
		if (index >= 0)
		{
			m_value = m_listView->GetFirstSelected();

			// TODO: Send event as well

			Dismiss();
		}
		else
			event.Skip();
    }

	// Enter chooses an item, escape exits with no change.
	void OnKeyUp(wxKeyEvent& event)
    {
		int keycode = event.GetKeyCode();
		if (keycode == WXK_RETURN)
		{
			m_value = m_listView->GetFirstSelected();
			Dismiss();
		}
		else if (keycode == WXK_ESCAPE)
		{
			m_value = -1;
			this->Dismiss();
		}
		else
		{
			event.Skip();
		}
    }

	void OnFocus(wxFocusEvent& cEvent)
	{
		cEvent;
		m_listView->SetFocus();
	}
	wxSize GetAdjustedSize(int minWidth, int minHeight, int maxHeight)
	{
		minHeight;
		maxHeight;
		return wxSize(minWidth, 100);
	}

protected:
	wxListView *    m_listView;
    int             m_value; // current item index
	wxString		m_initialValue; //The original value submitted by the combo box.
private:
    DECLARE_EVENT_TABLE()
};

#endif