## Makefile to build amd64 (64-bit) version of JS on Windows.
## This ASSUMES that you are running on a 64-bit machine (and
## not using the x86_amd64 cross-compiler) because one of the
## steps in the build process is to use one of the generated
## exe's, so we can't be cross-compiling from a 32-bit host
## that can't run the 64-bit exe.

OBJS = jsapi.obj jsarena.obj jsarray.obj jsatom.obj jsbool.obj jscntxt.obj jsdate.obj jsdbgapi.obj jsdhash.obj jsdtoa.obj jsemit.obj jsexn.obj jsfile.obj jsfun.obj jsgc.obj jshash.obj jsinterp.obj jsinvoke.obj jsiter.obj jslock.obj jslog2.obj jslong.obj jsmath.obj jsnum.obj jsobj.obj jsopcode.obj jsparse.obj jsprf.obj jsregexp.obj jsscan.obj jsscope.obj jsscript.obj jsstr.obj jsutil.obj jsxdrapi.obj jsxml.obj prmjtime.obj

.c.obj:
	cl -c -I. -I../../nspr-4.8.6-win-amd64/include/nspr -DJS_THREADSAFE -DXP_WIN -DEXPORT_JS_API -nologo -MD -Od -D_WIN64=1 -D_AMD64_=1 -D_CRT_SECURE_NO_DEPRECATE -DSTATIC_JS_API $?

spidermonkey.lib: jsautokw.h $(OBJS)
	lib /out:spidermonkey.lib $(OBJS)

jskwgen.exe: jskwgen.c
	cl -I. -DXP_WIN -DEXPORT_JS_API -nologo -MD -Od -D_WIN64=1 -D_AMD64_=1 -D_CRT_SECURE_NO_DEPRECATE jskwgen.c

jsautokw.h: jskwgen.exe jskeyword.tbl
	jskwgen.exe jsautokw.h jskeyword.tbl



